<div class="data-table-container">

    <div *ngIf="_settings" class="table-responsive data-table-responsive">

        <!-- TABLE -->
        <table class="table table-sm table-hover table-striped mb-0"
            aria-describedby="data-table"
            appSortTable
            (sorted)="onSort($event)"
            appFilterTable
            (filtered)="onFilter($event)">

            <!-- TABLE HEAD -->
            <thead>

                <!-- SORT -->
                <tr>
                    <th *ngIf="_settings.selectable">#</th>
                    <th scope="col" *ngFor="let column of displayedColumns">
                        {{column.title | translate}}<span [app-sortable-column]="column.name"></span>
                    </th>
                    <th scope="col" *ngIf="_settings.actions && _settings.actions.length > 0 && enableActions">
                        {{'DATA_TABLE.THEAD.ACTIONS_COL' | translate}}
                    </th>
                </tr>
                 <!-- END SORT -->

                <!-- FILTER -->
                <!-- <tr *ngIf="enableFilterColumn && _originalItems && _originalItems.length > 0">
                    <th *ngIf="_settings.selectable"></th>
                    <th scope="col" *ngFor="let column of displayedColumns">
                        <app-filter-column [columnName]="column.name"></app-filter-column>
                    </th>
                    <th scope="col" *ngIf="_settings.actions && _settings.actions.length > 0"></th>
                </tr> -->
                <!-- END FILTER -->

            </thead>
            <!-- END TABLE HEAD -->

            <!-- TABLE BODY -->
            <tbody>
                <tr *ngFor="let item of paginatedItems | sort : sortedColumn?.property : sortedColumn?.direction"
                    [ngClass]="{'cursor-pointer': _settings.clickable}">

                    <!-- CHECKBOX -->
                    <td *ngIf="_settings.selectable">
                      <input type="checkbox" (change)="onCheckedItem(item, $event.target.checked)" [checked]="item.checked">
                    </td>
                     <!-- END CHECKBOX -->

                    <!-- DATA -->
                    <td *ngFor="let column of displayedColumns" (click)="onSelectItem(item)">
                        <ng-container [ngSwitch]="column.format">
                            <ng-container *ngSwitchCase="'CURRENCY'">
                                <div [ngStyle]="getColumnStyle(column, item)">
                                    <a *ngIf="column.link" class="float-right" [routerLink]="[column.link]" [queryParams]="mapLinkParams(item, column.linkParams)">{{ item[column.name] | currency : pipeParameters.currency.display : pipeParameters.currency.digitsInfo }}</a>
                                    <span *ngIf="!column.link" class="float-right">{{ item[column.name] | currency : pipeParameters.currency.currencyCode : pipeParameters.currency.display : pipeParameters.currency.digitsInfo }}</span>
                                </div>
                            </ng-container>
                            <ng-container *ngSwitchCase="'NUMBER'">
                                <div [ngStyle]="getColumnStyle(column, item)">
                                    <a *ngIf="column.link" class="float-right" [routerLink]="[column.link]" [queryParams]="mapLinkParams(item, column.linkParams)">{{ item[column.name] | number : pipeParameters.number.digitsInfo }}</a>
                                    <span *ngIf="!column.link" class="float-right">{{ item[column.name] | number : pipeParameters.number.digitsInfo }}</span>
                                </div>
                            </ng-container>
                            <ng-container *ngSwitchCase="'DATE'">
                                <div [ngStyle]="getColumnStyle(column, item)">
                                    <a *ngIf="column.link" [routerLink]="[column.link]" [queryParams]="mapLinkParams(item, column.linkParams)">{{ item[column.name] | date: pipeParameters.date.formatNoTime }}</a>
                                    <span *ngIf="!column.link">{{ item[column.name] | date: pipeParameters.date.formatNoTime }}</span>
                                </div>
                            </ng-container>
                            <ng-container *ngSwitchCase="'PERCENT'" >
                                <div [ngStyle]="getColumnStyle(column, item)">
                                    <a *ngIf="column.link" [routerLink]="[column.link]" [queryParams]="mapLinkParams(item, column.linkParams)">{{item[column.name] !== null ? ((item[column.name] / 100) | percent: pipeParameters.percent.digitsInfo) : ''}}</a>
                                    <span *ngIf="!column.link">{{item[column.name] !== null ? ((item[column.name] / 100) | percent: pipeParameters.percent.digitsInfo) : ''}}</span>
                                </div>
                            </ng-container>
                            <ng-container *ngSwitchCase="'PROGRESS_BAR'" >
                                <div [ngStyle]="getColumnStyle(column, item)">
                                    <div class="progress">
                                        <div class="progress-bar progress-bar-danger progress-bar-striped" role="progressbar"
                                             aria-valuenow="{{item[column.name]}}" aria-valuemin="0" aria-valuemax="100" [style]="'width:'+item[column.name]+'%'">
                                          {{item[column.name] !== null ? ((item[column.name] / 100) | percent: pipeParameters.percent.digitsInfo) : ''}}
                                        </div>
                                    </div>
                                </div>
                            </ng-container>
                            <ng-container *ngSwitchCase="'ENUM'">
                                <div [ngStyle]="getColumnStyle(column, item)">
                                    <a *ngIf="column.link" [routerLink]="[column.link]" [queryParams]="mapLinkParams(item, column.linkParams)">{{ item[column.name] }}</a>
                                    <span *ngIf="!column.link">{{ extractEnumValue(item[column.name], column.enum) }}</span>
                                </div>
                            </ng-container>
                            <ng-container *ngSwitchCase="'STRING'">
                                <div [ngStyle]="getColumnStyle(column, item)">
                                    <a *ngIf="column.link" [routerLink]="[column.link]" [queryParams]="mapLinkParams(item, column.linkParams)">{{ item[column.name] }}</a>
                                    <span *ngIf="!column.link">{{ item[column.name] }}</span>
                                </div>
                            </ng-container>
                            <ng-container *ngSwitchDefault>
                                <div [ngStyle]="getColumnStyle(column, item)">
                                    <a *ngIf="column.link" [routerLink]="[column.link]" [queryParams]="mapLinkParams(item, column.linkParams)">{{ item[column.name] }}</a>
                                    <span *ngIf="!column.link">{{ item[column.name] }}</span>
                                </div>
                            </ng-container>
                        </ng-container>
                    </td>
                    <!-- END DATA -->

                    <!-- BUTTONS ACTION -->
                    <td *ngIf="_settings.actions && _settings.actions.length > 0 && enableActions" class="text-center">
                        <ng-container *ngFor="let action of _settings.actions">
                            <button *ngIf="action === 'VIEW'" class="btn btn-show td-ng-click btn-sm btn-action-table" [title]="'FIELD.BUTTONS.VIEW'|translate" (click)="onAction(item, action)">
                                <em class="fa fa-eye"></em>
                            </button>
                            <button *ngIf="action === 'EDIT' && !isRecap" class="btn btn-edit btn-sm td-ng-click btn-action-table" [title]="'FIELD.BUTTONS.EDIT'|translate" (click)="onAction(item, action)">
                                <em class="fa fa-edit"></em>
                            </button>
                            <button *ngIf="action === 'ROUTER' && !isRecap" class="btn btn-info btn-sm td-ng-click btn-action-table" [title]="'FIELD.BUTTONS.ROUTER'|translate" (click)="openDialog(item, action)">
                                <em class="fa fa-road"></em>
                            </button>
                            <button *ngIf="action === 'DOWNLOAD'  && !isRecap" class="btn btn-primary btn-sm btn-action-table" [title]="'FIELD.BUTTONS.DOWNLOAD'|translate" (click)="onAction(item, action)">
                                <em class="fa fa-download"></em>
                            </button>
                            <button *ngIf="action === 'CANCEL'  && !isRecap" class="btn btn-warning btn-sm btn-action-table" [title]="'FIELD.BUTTONS.CANCEL'|translate" (click)="openDialog(item, action)">
                                <em class="fa fa-times"></em>
                            </button>
                            <button *ngIf="action === 'DELETE'  && !isRecap" class="btn btn-delete btn-sm td-ng-click btn-action-table" [title]="'FIELD.BUTTONS.DELETE'|translate" (click)="onAction(item, action)">
                                <em class="fa fa-trash"></em>
                            </button>
                            <button *ngIf="action === 'EXPORT' &&  !isRecap" class="btn  btn-sm td-ng-click btn-action-table" [title]="'FIELD.BUTTONS.EXPORT'|translate" (click)="onAction(item, action)" (click)="onVisible(item)" >
                                <i class="fa fa-arrow-circle-right" aria-hidden="true"></i>
                            </button>
                        </ng-container>
                    </td>
                    
                </tr>
                <!-- END BUTTONS ACTION -->

                <!-- NO DATA MSG -->
                <tr *ngIf="(!paginatedItems  || paginatedItems.length === 0) && !enableLoading" class="alert-row">
                    <td [attr.colspan]="displayedColumns?.length + _settings.actions?.length + (_settings.selectable ? 1 : 0)">
                        <div class="alert alert-primary text-center" role="alert">
                            <div class="iq-alert-icon text-center">
                                <i class="ri-information-line"></i>
                            </div>
                            <div class="iq-alert-text">{{'FIELD.PLEASE.NO_DATA'|translate}}</div>
                        </div>
                    </td>
                </tr>
                <!-- END NO DATA MSG -->

                <!-- LOADING -->
                <tr *ngIf="enableLoading" class="loading-row">
                    <td [attr.colspan]="displayedColumns?.length + _settings.actions?.length + (_settings.selectable ? 1 : 0)">
                        <div class="text-center panel-spinner">
                            <em class="fa fa-spinner fa-spin fa-2x"></em>
                        </div>
                    </td>
                </tr>
                <!-- END LOADING -->

            </tbody>
            <!-- END TABLE BODY -->

        </table>
        <!-- END TABLE -->
    </div>

    <!-- PAGINATION -->
    <div class="mt-2">
      <ng-container *ngIf="_items?.length > 0">

        <app-pagination
            [totalItems]="_items ? _items.length : null"
            [itemsPerPage]="itemsPerPage"
            [maxSize]="9"
            [boundaryLinks]="true"
            (pageChanged)="currentPage = $event; paginate();">
        </app-pagination>

      </ng-container>
    </div>
    <!-- END PAGINATION -->

</div>
